﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.filters.ColorMatrixFilter;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	
	import uk.co.soulwire.cv.MotionTracker;

	public class Suiveur extends Sprite
	{
		private var mover:Sprite;
		private var i:Number = 0;
		
		private var _motionTracker : MotionTracker;
		private var _target : Shape;
		private var _bounds : Shape;
		private var _back : MovieClip;
		private var _output : Bitmap;
		private var _video : BitmapData;
		private var bool : Boolean;
		private var movement :Sprite;
		

		public function Suiveur()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			var camW : int = stage.stageWidth;
			var camH : int = stage.stageHeight;

			var cam : Camera = Camera.getCamera();
			cam.setMode(camW, camH, stage.frameRate);
			var vid : Video = new Video(camW, camH);
			vid.attachCamera(cam);
			
			_motionTracker = new MotionTracker(vid);
			
			_motionTracker.flipInput = true;

			_video = new BitmapData(camW, camH, false, 0);

			_output = new Bitmap(_motionTracker.trackingImage);
			_output.x = 0;
			_output.y = 0;
			_back = new MovieClip();
			addChild(_back);
			//addChild(_output);
			
			_target = new Shape();
			_target.graphics.lineStyle(0, 0xFFFFFF);
			_target.graphics.drawCircle(0, 0, 10);
			//addChild(_target);
			
			_bounds = new Shape();
			_bounds.x = _output.x;
			_bounds.y = _output.y;
			//addChild(_bounds);
			

			mover = new Sprite();
			addChild(mover);
			
			bool = true;
			addEventListener(Event.ENTER_FRAME, enterHandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, Click);


		}
		private function enterHandler(e:Event):void
		{
	

			_motionTracker.track();
			
			_target.x += ((_motionTracker.x) - _target.x) / 10;
			_target.y += ((_motionTracker.y) - _target.y) / 10;
			
			trace(_target.x/1000);
			mover.x = - _target.x;
			mover.y = - _target.y;
			drawElem(i++);
			if ( !_motionTracker.hasMovement ) return;
			
			//_bounds.graphics.clear();
			//_bounds.graphics.lineStyle(0, 0xFFFFFF);
			//_bounds.graphics.drawRect(_motionTracker.motionArea.x, _motionTracker.motionArea.y, _motionTracker.motionArea.width, _motionTracker.motionArea.height);
		}
		private function Click(e:Event):void
		{
			trace(bool);
			if(bool == true){
			_back.addChild(_output);
			_back.addChild(_bounds);
			bool = false;
			} else {
				bool = true;
				_back.removeChild(_output);
			}
		}
		
		private function drawElem(nbr:Number):void
		{
			var elem:Sprite = new Sprite();
			elem.name = "ch"+i;
			elem.graphics.beginFill(0xffffff,1);
			elem.graphics.drawCircle(stage.stageWidth/2 - mover.x,stage.stageHeight/2 - mover.y,Math.sin(i*Math.PI/180)*30);
			elem.graphics.endFill();
			elem.addEventListener(Event.ENTER_FRAME,fadeOut);
			mover.addChild(elem);
		}
		private function fadeOut(e:Event):void{
			e.currentTarget.x += Math.random()*0;
			e.currentTarget.y += Math.random()*0;
			e.currentTarget.alpha-=0.009;
			if(e.currentTarget.alpha<=0){
				if(mover.getChildByName(e.currentTarget.name)!=null){
					e.currentTarget.removeEventListener(Event.ENTER_FRAME,fadeOut);
					mover.removeChild(mover.getChildByName(e.currentTarget.name));
				}
			}
		
		
		}
	}
}